From 2e89b706f5c956a70c989cd31665f1429e9a0b48 Mon Sep 17 00:00:00 2001
From: Samuel Holland <samuel@sholland.org>
Date: Mon, 31 Oct 2022 23:27:08 -0500
Subject: [PATCH 68/68] sunxi: riscv: Add defconfigs for several boards

Signed-off-by: Samuel Holland <samuel@sholland.org>
---
 configs/devterm_r_01_defconfig       | 17 +++++++++++++++++
 configs/dongshan_nezha_stu_defconfig | 20 ++++++++++++++++++++
 configs/lichee_rv_86_panel_defconfig | 20 ++++++++++++++++++++
 configs/lichee_rv_dock_defconfig     | 17 +++++++++++++++++
 configs/mangopi_mq_pro_defconfig     | 17 +++++++++++++++++
 configs/nezha_defconfig              | 21 +++++++++++++++++++++
 6 files changed, 112 insertions(+)
 create mode 100644 configs/devterm_r_01_defconfig
 create mode 100644 configs/dongshan_nezha_stu_defconfig
 create mode 100644 configs/lichee_rv_86_panel_defconfig
 create mode 100644 configs/lichee_rv_dock_defconfig
 create mode 100644 configs/mangopi_mq_pro_defconfig
 create mode 100644 configs/nezha_defconfig

--- /dev/null
+++ b/configs/devterm_r_01_defconfig
@@ -0,0 +1,17 @@
+CONFIG_RISCV=y
+CONFIG_HAS_CUSTOM_SYS_INIT_SP_ADDR=y
+CONFIG_CUSTOM_SYS_INIT_SP_ADDR=0x43e00000
+CONFIG_DEFAULT_DEVICE_TREE="sun20i-d1-devterm-v3.14"
+CONFIG_TARGET_SUN20I_D1=y
+CONFIG_ARCH_RV64I=y
+CONFIG_RISCV_SMODE=y
+# CONFIG_SPL_SMP is not set
+CONFIG_SPL_SYS_MALLOC=y
+CONFIG_SPL_OPENSBI_SCRATCH_OPTIONS=0x0
+# CONFIG_SYS_I2C_MVTWSI is not set
+CONFIG_DRAM_SUN20I_D1=y
+CONFIG_DRAM_SUNXI_ODT_EN=0x1
+CONFIG_DRAM_SUNXI_TPR0=0x004a2195
+CONFIG_DRAM_SUNXI_TPR11=0x00870000
+CONFIG_DRAM_SUNXI_TPR12=0x00000024
+CONFIG_DRAM_SUNXI_TPR13=0x34050100
--- /dev/null
+++ b/configs/dongshan_nezha_stu_defconfig
@@ -0,0 +1,20 @@
+CONFIG_RISCV=y
+CONFIG_HAS_CUSTOM_SYS_INIT_SP_ADDR=y
+CONFIG_CUSTOM_SYS_INIT_SP_ADDR=0x43e00000
+CONFIG_DEFAULT_DEVICE_TREE="sun20i-d1-dongshan-nezha-stu"
+CONFIG_TARGET_SUN20I_D1=y
+CONFIG_ARCH_RV64I=y
+CONFIG_RISCV_SMODE=y
+# CONFIG_SPL_SMP is not set
+CONFIG_SPL_SYS_MALLOC=y
+CONFIG_SPL_OPENSBI_SCRATCH_OPTIONS=0x0
+CONFIG_NET_RANDOM_ETHADDR=y
+# CONFIG_SYS_I2C_MVTWSI is not set
+CONFIG_PHY_REALTEK=y
+CONFIG_SUN8I_EMAC=y
+CONFIG_DRAM_SUN20I_D1=y
+CONFIG_DRAM_SUNXI_ODT_EN=0x1
+CONFIG_DRAM_SUNXI_TPR0=0x004a2195
+CONFIG_DRAM_SUNXI_TPR11=0x00870000
+CONFIG_DRAM_SUNXI_TPR12=0x00000024
+CONFIG_DRAM_SUNXI_TPR13=0x34050100
--- /dev/null
+++ b/configs/lichee_rv_86_panel_defconfig
@@ -0,0 +1,20 @@
+CONFIG_RISCV=y
+CONFIG_HAS_CUSTOM_SYS_INIT_SP_ADDR=y
+CONFIG_CUSTOM_SYS_INIT_SP_ADDR=0x43e00000
+CONFIG_DEFAULT_DEVICE_TREE="sun20i-d1-lichee-rv-86-panel-480p"
+CONFIG_TARGET_SUN20I_D1=y
+CONFIG_ARCH_RV64I=y
+CONFIG_RISCV_SMODE=y
+# CONFIG_SPL_SMP is not set
+CONFIG_SPL_SYS_MALLOC=y
+CONFIG_SPL_OPENSBI_SCRATCH_OPTIONS=0x0
+CONFIG_NET_RANDOM_ETHADDR=y
+# CONFIG_SYS_I2C_MVTWSI is not set
+CONFIG_PHY_REALTEK=y
+CONFIG_SUN8I_EMAC=y
+CONFIG_DRAM_SUN20I_D1=y
+CONFIG_DRAM_SUNXI_ODT_EN=0x1
+CONFIG_DRAM_SUNXI_TPR0=0x004a2195
+CONFIG_DRAM_SUNXI_TPR11=0x00870000
+CONFIG_DRAM_SUNXI_TPR12=0x00000024
+CONFIG_DRAM_SUNXI_TPR13=0x34050100
--- /dev/null
+++ b/configs/lichee_rv_dock_defconfig
@@ -0,0 +1,17 @@
+CONFIG_RISCV=y
+CONFIG_HAS_CUSTOM_SYS_INIT_SP_ADDR=y
+CONFIG_CUSTOM_SYS_INIT_SP_ADDR=0x43e00000
+CONFIG_DEFAULT_DEVICE_TREE="sun20i-d1-lichee-rv-dock"
+CONFIG_TARGET_SUN20I_D1=y
+CONFIG_ARCH_RV64I=y
+CONFIG_RISCV_SMODE=y
+# CONFIG_SPL_SMP is not set
+CONFIG_SPL_SYS_MALLOC=y
+CONFIG_SPL_OPENSBI_SCRATCH_OPTIONS=0x0
+# CONFIG_SYS_I2C_MVTWSI is not set
+CONFIG_DRAM_SUN20I_D1=y
+CONFIG_DRAM_SUNXI_ODT_EN=0x1
+CONFIG_DRAM_SUNXI_TPR0=0x004a2195
+CONFIG_DRAM_SUNXI_TPR11=0x00870000
+CONFIG_DRAM_SUNXI_TPR12=0x00000024
+CONFIG_DRAM_SUNXI_TPR13=0x34050100
--- /dev/null
+++ b/configs/mangopi_mq_pro_defconfig
@@ -0,0 +1,17 @@
+CONFIG_RISCV=y
+CONFIG_HAS_CUSTOM_SYS_INIT_SP_ADDR=y
+CONFIG_CUSTOM_SYS_INIT_SP_ADDR=0x43e00000
+CONFIG_DEFAULT_DEVICE_TREE="sun20i-d1-mangopi-mq-pro"
+CONFIG_TARGET_SUN20I_D1=y
+CONFIG_ARCH_RV64I=y
+CONFIG_RISCV_SMODE=y
+# CONFIG_SPL_SMP is not set
+CONFIG_SPL_SYS_MALLOC=y
+CONFIG_SPL_OPENSBI_SCRATCH_OPTIONS=0x0
+# CONFIG_SYS_I2C_MVTWSI is not set
+CONFIG_DRAM_SUN20I_D1=y
+CONFIG_DRAM_SUNXI_ODT_EN=0x1
+CONFIG_DRAM_SUNXI_TPR0=0x004a2195
+CONFIG_DRAM_SUNXI_TPR11=0x00870000
+CONFIG_DRAM_SUNXI_TPR12=0x00000024
+CONFIG_DRAM_SUNXI_TPR13=0x34050100
--- /dev/null
+++ b/configs/nezha_defconfig
@@ -0,0 +1,21 @@
+CONFIG_RISCV=y
+CONFIG_HAS_CUSTOM_SYS_INIT_SP_ADDR=y
+CONFIG_CUSTOM_SYS_INIT_SP_ADDR=0x43e00000
+CONFIG_DEFAULT_DEVICE_TREE="sun20i-d1-nezha"
+CONFIG_TARGET_SUN20I_D1=y
+CONFIG_ARCH_RV64I=y
+CONFIG_RISCV_SMODE=y
+# CONFIG_SPL_SMP is not set
+CONFIG_SPL_SYS_MALLOC=y
+CONFIG_SPL_OPENSBI_SCRATCH_OPTIONS=0x0
+CONFIG_NET_RANDOM_ETHADDR=y
+# CONFIG_SYS_I2C_MVTWSI is not set
+CONFIG_PHY_REALTEK=y
+CONFIG_SUN8I_EMAC=y
+CONFIG_DRAM_SUN20I_D1=y
+CONFIG_DRAM_SUNXI_ODT_EN=0x1
+CONFIG_DRAM_SUNXI_TPR0=0x004a2195
+CONFIG_DRAM_SUNXI_TPR11=0x00870000
+CONFIG_DRAM_SUNXI_TPR12=0x00000024
+CONFIG_DRAM_SUNXI_TPR13=0x34050100
+CONFIG_VIDEO=y